<?php
class ControllerExtensionModuleTargetsms extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/module/targetsms');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');
		$this->load->model('setting/store');
		$this->load->model('localisation/order_status');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {

			foreach ($this->request->post['stores'] as $key => $store) {

				$store['module_targetsms_status'] = 1;
				$this->model_setting_setting->editSetting('module_targetsms', $store, $key);
				
			}
			
			

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
		}

		$data['action'] = $this->url->link('extension/module/targetsms', 'user_token=' . $this->session->data['user_token'], true);
		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);

		$data['token'] = $this->session->data['user_token'];

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_loading'] = $this->language->get('text_loading');
        $data['text_confirm'] = $this->language->get('text_confirm');
		$data['text_phone_placeholder'] = $this->language->get('text_phone_placeholder');

		$data['tab_connect'] = $this->language->get('tab_connect');
		$data['tab_test'] = $this->language->get('tab_test');
		$data['tab_admin'] = $this->language->get('tab_admin');
		$data['tab_email_admin'] = $this->language->get('tab_email_admin');
		$data['tab_customer'] = $this->language->get('tab_customer');
		$data['tab_history'] = $this->language->get('tab_history');
		$data['tab_email_history'] = $this->language->get('tab_email_history');

		$data['entry_targetsms_login'] = $this->language->get('entry_targetsms_login');
		$data['entry_targetsms_password'] = $this->language->get('entry_targetsms_password');
		$data['entry_targetsms_from'] = $this->language->get('entry_targetsms_from');
		$data['entry_targetsms_balance'] = $this->language->get('entry_targetsms_balance');
		$data['entry_targetsms_store'] = $this->language->get('entry_targetsms_store');
		$data['entry_targetsms_to'] = $this->language->get('entry_targetsms_to');
		$data['entry_targetsms_admin_send'] = $this->language->get('entry_targetsms_admin_send');
		$data['entry_targetsms_admin_template'] = $this->language->get('entry_targetsms_admin_template');
		$data['entry_targetsms_admin_template_defaul'] = $this->language->get('entry_targetsms_admin_template_defaul');


		$data['entry_targetsms_email_to'] = $this->language->get('entry_targetsms_email_to');
		$data['entry_targetsms_email_admin_send'] = $this->language->get('entry_targetsms_email_admin_send');
		$data['entry_targetsms_email_admin_template'] = $this->language->get('entry_targetsms_email_admin_template');
		$data['entry_targetsms_email_admin_template_defaul'] = $this->language->get('entry_targetsms_email_admin_template_defaul');
		$data['entry_targetsms_email_admin_subject'] = $this->language->get('entry_targetsms_email_admin_subject');
		$data['entry_targetsms_email_admin_subject_defaul'] = $this->language->get('entry_targetsms_email_admin_subject_defaul');

		$data['entry_targetsms_email_customer_send'] = $this->language->get('entry_targetsms_email_customer_send');
		$data['entry_targetsms_email_customer_order_status'] = $this->language->get('entry_targetsms_email_customer_order_status');
		$data['entry_targetsms_email_customer_templates'] = $this->language->get('entry_targetsms_email_customer_templates');
		$data['entry_targetsms_email_customer_order_status_template_defaul'] = $this->language->get('entry_targetsms_email_customer_order_status_template_defaul');
		$data['entry_targetsms_email_customer_order_status_subject_defaul'] = $this->language->get('entry_targetsms_email_customer_order_status_subject_defaul');

		$data['entry_targetsms_customer_send'] = $this->language->get('entry_targetsms_customer_send');
		$data['entry_targetsms_customer_order_status'] = $this->language->get('entry_targetsms_customer_order_status');
		$data['entry_targetsms_customer_templates'] = $this->language->get('entry_targetsms_customer_templates');
		$data['entry_targetsms_customer_order_status_template_defaul'] = $this->language->get('entry_targetsms_customer_order_status_template_defaul');
		$data['entry_date_send_start'] = $this->language->get('entry_date_send_start');
		$data['entry_date_send_stop'] = $this->language->get('entry_date_send_stop');
		$data['entry_sms_status']	= $this->language->get('entry_sms_status');
		$data['entry_sms_status_deliver']	= $this->language->get('entry_sms_status_deliver');
		$data['entry_sms_status_partly_deliver']	= $this->language->get('entry_sms_status_partly_deliver');
		$data['entry_sms_status_expired']	= $this->language->get('entry_sms_status_expired');
		$data['entry_sms_status_not_deliver']	= $this->language->get('entry_sms_status_not_deliver');
		$data['entry_targetsms_test_phone']	= $this->language->get('entry_targetsms_test_phone');
		$data['entry_targetsms_test_message']	= $this->language->get('entry_targetsms_test_message');


		$data['entry_email_status']	= $this->language->get('entry_email_status');


		$data['entry_history_sms_id']	= $this->language->get('entry_history_sms_id');
		$data['entry_history_sms_sender']	= $this->language->get('entry_history_sms_sender');
		$data['entry_history_sms_recipient']	= $this->language->get('entry_history_sms_recipient');
		$data['entry_history_sms_text']	= $this->language->get('entry_history_sms_text');
		$data['entry_history_sms_status']	= $this->language->get('entry_history_sms_status');
		$data['entry_history_sms_date']	= $this->language->get('entry_history_sms_date');

		$data['entry_history_email_id']	= $this->language->get('entry_history_email_id');
		$data['entry_history_email_recipient']	= $this->language->get('entry_history_email_recipient');
		$data['entry_history_email_subject']	= $this->language->get('entry_history_email_subject');
		$data['entry_history_email_text']	= $this->language->get('entry_history_email_text');
		$data['entry_history_email_status']	= $this->language->get('entry_history_email_status');
		$data['entry_history_email_date']	= $this->language->get('entry_history_email_date');



		$data['help_targetsms_to'] = $this->language->get('help_targetsms_to');
		$data['help_targetsms_admin_template'] = $this->language->get('help_targetsms_admin_template');
		$data['help_targetsms_customer_order_status'] = $this->language->get('help_targetsms_customer_order_status');
		$data['help_targetsms_customer_template'] = $this->language->get('help_targetsms_customer_template');
		$data['help_targetsms_test_phone'] = $this->language->get('help_targetsms_test_phone');


		$data['help_targetsms_email_to'] = $this->language->get('help_targetsms_email_to');
		$data['help_targetsms_email_admin_template'] = $this->language->get('help_targetsms_email_admin_template');
		$data['help_targetsms_email_admin_subject'] = $this->language->get('help_targetsms_email_admin_subject');
		$data['help_targetsms_email_customer_order_status'] = $this->language->get('help_targetsms_email_customer_order_status');
		$data['help_targetsms_email_customer_template'] = $this->language->get('help_targetsms_email_customer_template');
		$data['help_targetsms_email_customer_subject'] = $this->language->get('help_targetsms_email_customer_subject');

	
		$data['button_filter'] = $this->language->get('button_filter');
		$data['button_connect'] = $this->language->get('button_connect');
		$data['button_send'] = $this->language->get('button_send');
		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$data['error_name'] = $this->error['name'];
		} else {
			$data['error_name'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/module/targetsms', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['stores'] = array();
		$data['stores'][] = array(
			'store_id' => 0,
			'name' => $this->language->get('entry_targetsms_store_default')
		);

		$stores = $this->model_setting_store->getStores();



		foreach ($stores as $key => $store) {
			$data['stores'][] = array(
				'store_id' => $store['store_id'],
				'name' => $store['name']
			);
		}

		foreach ($data['stores'] as $key => $store) {

			if (isset($this->request->post['stores'][$key]['module_targetsms_login'])) {
		    	$data['stores'][$key]['module_targetsms_login'] = $this->request->post['stores'][$key]['module_targetsms_login'];
		    } else {
		    	$data['stores'][$key]['module_targetsms_login'] = $this->model_setting_setting->getSettingValue('module_targetsms_login',$store['store_id']);
		    }
		    if (isset($this->request->post['stores'][$key]['module_targetsms_password'])) {
		    	$data['stores'][$key]['module_targetsms_password'] = $this->request->post['stores'][$key]['module_targetsms_password'];
		    } else {
		    	$data['stores'][$key]['module_targetsms_password'] = $this->model_setting_setting->getSettingValue('module_targetsms_password',$store['store_id']);
		    }
		    if (isset($this->request->post['stores'][$key]['module_targetsms_from'])) {
		    	$data['stores'][$key]['module_targetsms_from'] = $this->request->post['stores'][$key]['module_targetsms_from'];
		    } else {
		    	$data['stores'][$key]['module_targetsms_from'] = $this->model_setting_setting->getSettingValue('module_targetsms_from',$store['store_id']);
		    }

		    if ($data['stores'][$key]['module_targetsms_login'] && $data['stores'][$key]['module_targetsms_password']) {
		    	$data['stores'][$key]['senders'] = $this->getSenders($data['stores'][$key]['module_targetsms_login'],$data['stores'][$key]['module_targetsms_password']);
		    	$data['stores'][$key]['balance'] = $this->getBalance($data['stores'][$key]['module_targetsms_login'],$data['stores'][$key]['module_targetsms_password']);	
		    	if (!$data['stores'][$key]['balance']) {
		    		$data['stores'][$key]['balance'] = '0.00';
		    	} 
		    } else {
		    	$data['stores'][$key]['senders'] = array();
		    	$data['stores'][$key]['balance'] = '0.00';
		    }

		    $data['stores'][$key]['balance'] = $data['stores'][$key]['balance'] . " руб.";

		    if (isset($this->request->post['stores'][$key]['module_targetsms_to'])) {
		    	$data['stores'][$key]['module_targetsms_to'] = $this->request->post['stores'][$key]['module_targetsms_to'];
		    } else {
		    	$data['stores'][$key]['module_targetsms_to'] = $this->model_setting_setting->getSettingValue('module_targetsms_to',$store['store_id']);
		    }

		    if (isset($this->request->post['stores'][$key]['module_targetsms_email_to'])) {
		    	$data['stores'][$key]['module_targetsms_email_to'] = $this->request->post['stores'][$key]['module_targetsms_email_to'];
		    } else {
		    	$data['stores'][$key]['module_targetsms_email_to'] = $this->model_setting_setting->getSettingValue('module_targetsms_email_to',$store['store_id']);
		    }

		    if (isset($this->request->post['stores'][$key]['module_targetsms_admin_send'])) {
		    	$data['stores'][$key]['module_targetsms_admin_send'] = $this->request->post['stores'][$key]['module_targetsms_admin_send'];
		    } else if ($this->model_setting_setting->getSettingValue('module_targetsms_admin_send',$store['store_id'])) {
		    	$data['stores'][$key]['module_targetsms_admin_send'] = $this->model_setting_setting->getSettingValue('module_targetsms_admin_send',$store['store_id']);
		    } else {
		    	$data['stores'][$key]['module_targetsms_admin_send'] = '';
		    }

		    if (isset($this->request->post['stores'][$key]['module_targetsms_email_admin_send'])) {
		    	$data['stores'][$key]['module_targetsms_email_admin_send'] = $this->request->post['stores'][$key]['module_targetsms_email_admin_send'];
		    } else if ($this->model_setting_setting->getSettingValue('module_targetsms_email_admin_send',$store['store_id'])) {
		    	$data['stores'][$key]['module_targetsms_email_admin_send'] = $this->model_setting_setting->getSettingValue('module_targetsms_email_admin_send',$store['store_id']);
		    } else {
		    	$data['stores'][$key]['module_targetsms_email_admin_send'] = '';
		    }

		    if (isset($this->request->post['stores'][$key]['module_targetsms_admin_template'])) {
		    	$data['stores'][$key]['module_targetsms_admin_template'] = $this->request->post['stores'][$key]['module_targetsms_admin_template'];
		    } else {
		    	$data['stores'][$key]['module_targetsms_admin_template'] = $this->model_setting_setting->getSettingValue('module_targetsms_admin_template',$store['store_id']);
		    }

		    if (isset($this->request->post['stores'][$key]['module_targetsms_email_admin_subject'])) {
		    	$data['stores'][$key]['module_targetsms_email_admin_subject'] = $this->request->post['stores'][$key]['module_targetsms_email_admin_subject'];
		    } else {
		    	$data['stores'][$key]['module_targetsms_email_admin_subject'] = $this->model_setting_setting->getSettingValue('module_targetsms_email_admin_subject',$store['store_id']);
		    }

		    if (isset($this->request->post['stores'][$key]['module_targetsms_email_admin_template'])) {
		    	$data['stores'][$key]['module_targetsms_email_admin_template'] = $this->request->post['stores'][$key]['module_targetsms_email_admin_template'];
		    } else {
		    	$data['stores'][$key]['module_targetsms_email_admin_template'] = $this->model_setting_setting->getSettingValue('module_targetsms_email_admin_template',$store['store_id']);
		    }

		    if (isset($this->request->post['stores'][$key]['module_targetsms_customer_order_status'])) {
				$data['stores'][$key]['module_targetsms_customer_order_status'] = $this->request->post['stores'][$key]['module_targetsms_customer_order_status'];
			} elseif ($this->model_setting_setting->getSettingValue('module_targetsms_customer_order_status',$store['store_id'])) {
				$data['stores'][$key]['module_targetsms_customer_order_status'] =  json_decode($this->model_setting_setting->getSettingValue('module_targetsms_customer_order_status',$store['store_id']));
			} else {
				$data['stores'][$key]['module_targetsms_customer_order_status'] = array();
			}

			if (isset($this->request->post['stores'][$key]['module_targetsms_email_customer_order_status'])) {
				$data['stores'][$key]['module_targetsms_email_customer_order_status'] = $this->request->post['stores'][$key]['module_targetsms_email_customer_order_status'];
			} elseif ($this->model_setting_setting->getSettingValue('module_targetsms_email_customer_order_status',$store['store_id'])) {
				$data['stores'][$key]['module_targetsms_email_customer_order_status'] =  json_decode($this->model_setting_setting->getSettingValue('module_targetsms_email_customer_order_status',$store['store_id']));
			} else {
				$data['stores'][$key]['module_targetsms_email_customer_order_status'] = array();
			}

		    if (isset($this->request->post['stores'][$key]['module_targetsms_customer_order_status_template'])) {
				$data['stores'][$key]['module_targetsms_customer_order_status_template'] = $this->request->post['stores'][$key]['module_targetsms_customer_order_status'];
			} elseif ($this->model_setting_setting->getSettingValue('module_targetsms_customer_order_status_template',$store['store_id'])) {
				$data['stores'][$key]['module_targetsms_customer_order_status_template'] =  (array)json_decode($this->model_setting_setting->getSettingValue('module_targetsms_customer_order_status_template',$store['store_id']));
			} else {
				$data['stores'][$key]['module_targetsms_customer_order_status_template'] = array();
			}

			if (isset($this->request->post['stores'][$key]['module_targetsms_email_customer_order_status_template'])) {
				$data['stores'][$key]['module_targetsms_email_customer_order_status_template'] = $this->request->post['stores'][$key]['module_targetsms_email_customer_order_status_template'];
			} elseif ($this->model_setting_setting->getSettingValue('module_targetsms_email_customer_order_status_template',$store['store_id'])) {
				$data['stores'][$key]['module_targetsms_email_customer_order_status_template'] =  (array)json_decode($this->model_setting_setting->getSettingValue('module_targetsms_email_customer_order_status_template',$store['store_id']));
			} else {
				$data['stores'][$key]['module_targetsms_email_customer_order_status_template'] = array();
			}

			if (isset($this->request->post['stores'][$key]['module_targetsms_email_customer_order_status_subject'])) {
				$data['stores'][$key]['module_targetsms_email_customer_order_status_subject'] = $this->request->post['stores'][$key]['module_targetsms_email_customer_order_status_subject'];
			} elseif ($this->model_setting_setting->getSettingValue('module_targetsms_email_customer_order_status_subject',$store['store_id'])) {
				$data['stores'][$key]['module_targetsms_email_customer_order_status_subject'] =  (array)json_decode($this->model_setting_setting->getSettingValue('module_targetsms_email_customer_order_status_subject',$store['store_id']));
			} else {
				$data['stores'][$key]['module_targetsms_email_customer_order_status_subject'] = array();
			}



		    //var_dump($data['stores'][$key]['module_targetsms_customer_order_status_template']);exit;
			
		}


		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		//$data['messages'] = $this->getMessages();

		//$data['sms'] = $this->sendNewSms();

	

		$data['sms_gatenames'] = array();

		$files = glob(DIR_SYSTEM . 'smsgate/*.php');

		foreach ($files as $file) {
			$data['sms_gatenames'][] =  basename($file, '.php');
		}

	    if (isset($this->request->post['sms_notify_gatename'])) {
	      $data['sms_notify_gatename'] = $this->request->post['sms_notify_gatename'];
	    } else {
	      $data['sms_notify_gatename'] = $this->config->get('sms_notify_gatename');
	    }

	    if (isset($this->request->post['sms_notify_to'])) {
	      $data['sms_notify_to'] = $this->request->post['sms_notify_to'];
	    } else {
	      $data['sms_notify_to'] = $this->config->get('sms_notify_to');
	    }

	    if (isset($this->request->post['sms_notify_from'])) {
	      $data['sms_notify_from'] = $this->request->post['sms_notify_from'];
	    } else {
	      $data['sms_notify_from'] = $this->config->get('sms_notify_from');
	    }

	    if (isset($this->request->post['sms_notify_message'])) {
	      $data['sms_notify_message'] = $this->request->post['sms_notify_message'];
	    } else {
	      $data['sms_notify_message'] = $this->config->get('sms_notify_message');
	    }

	    if (isset($this->request->post['sms_notify_gate_username'])) {
	      $data['sms_notify_gate_username'] = $this->request->post['sms_notify_gate_username'];
	    } else {
	      $data['sms_notify_gate_username'] = $this->config->get('sms_notify_gate_username');
	    }

	    if (isset($this->request->post['sms_notify_gate_password'])) {
	      $data['sms_notify_gate_password'] = $this->request->post['sms_notify_gate_password'];
	    } else {
	      $data['sms_notify_gate_password'] = $this->config->get('sms_notify_gate_password');
	    }

	    if (isset($this->request->post['sms_notify_alert'])) {
	      $data['sms_notify_alert'] = $this->request->post['sms_notify_alert'];
	    } else {
	      $data['sms_notify_alert'] = $this->config->get('sms_notify_alert');
	    }

	    if (isset($this->request->post['sms_notify_copy'])) {
	      $data['sms_notify_copy'] = $this->request->post['sms_notify_copy'];
	    } else {
	      $data['sms_notify_copy'] = $this->config->get('sms_notify_copy');
	    }

	    if (isset($this->request->post['sms_notify_admin_alert'])) {
	      $data['admin_alert'] = $this->request->post['sms_notify_admin_alert'];
	    } elseif ($this->config->get('sms_notify_admin_alert')) {
	      $data['admin_alert'] = $this->config->get('sms_notify_admin_alert');
	    } else {
	      $data['admin_alert'] = '';
	    }
	    
	    if (isset($this->request->post['sms_notify_client_alert'])) {
	      $data['client_alert'] = $this->request->post['sms_notify_client_alert'];
	    } elseif ($this->config->get('sms_notify_client_alert')) {
	      $data['client_alert'] = $this->config->get('sms_notify_client_alert');
	    } else {
	      $data['client_alert'] = '';
	    }

	    if (isset($this->request->post['sms_notify_order_alert'])) {
	      $data['order_alert'] = $this->request->post['sms_notify_order_alert'];
	    } elseif ($this->config->get('sms_notify_order_alert')) {
	      $data['order_alert'] = $this->config->get('sms_notify_order_alert');
	    } else {
	      $data['order_alert'] = '';
	    }

		if (isset($this->request->post['sms_notify_admin_template'])) {
			$data['admin_template'] = $this->request->post['sms_notify_admin_template'];
		} elseif ($this->config->get('sms_notify_admin_template')) {
			$data['admin_template'] = $this->config->get('sms_notify_admin_template');
		} else {
			$data['admin_template'] = '';
		}

		if (isset($this->request->post['sms_notify_client_template'])) {
			$data['client_template'] = $this->request->post['sms_notify_client_template'];
		} elseif ($this->config->get('sms_notify_client_template')) {
			$data['client_template'] = $this->config->get('sms_notify_client_template');
		} else {
			$data['client_template'] = '';
		}

	    //CKEditor
	    if ($this->config->get('config_editor_default')) {
	        $this->document->addScript('view/javascript/ckeditor/ckeditor.js');
	        $this->document->addScript('view/javascript/ckeditor/ckeditor_init.js');
	    }

		$data['ckeditor'] = $this->config->get('config_editor_default');

		$data['lang'] = $this->language->get('lang');

		if (isset($this->request->post['sms_notify_sms_template'])) {
			$data['sms_template'] = $this->request->post['sms_notify_sms_template'];
		} elseif ($this->config->get('sms_notify_sms_template')) {
			$data['sms_template'] = html_entity_decode($this->config->get('sms_notify_sms_template'), ENT_QUOTES, 'UTF-8');
		} else {
			$data['sms_template'] = '';
		}

		$this->load->model('localisation/order_status');

		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		if (isset($this->request->post['sms_notify_status_template'])) {
			$data['order_status_template'] = $this->request->post['sms_notify_status_template'];
		} elseif ($this->config->get('sms_notify_status_template')) {
			$data['order_status_template'] = $this->config->get('sms_notify_status_template');
		} else {
			$data['order_status_template'] = array();
		}

		if (isset($this->request->post['sms_notify_order_status'])) {
			$data['sms_order_status'] = $this->request->post['sms_notify_order_status'];
		} elseif ($this->config->get('sms_notify_order_status')) {
			$data['sms_order_status'] = $this->config->get('sms_notify_order_status');
		} else {
			$data['sms_order_status'] = array();
		}

        if (isset($this->request->post['sms_notify_log'])) {
            $data['sms_notify_log'] = $this->request->post['sms_notify_log'];
        } elseif ($this->config->get('sms_notify_log')) {
            $data['sms_notify_log'] = $this->config->get('sms_notify_log');
        } else {
            $data['sms_notify_log'] = '';
        }

        $data['sms_log'] = '';

        $data['sms_log_filname'] = 'sms_log.log';

		if($this->config->get('sms_notify_log')){
	        $file = DIR_LOGS . $data['sms_log_filname'];

	        if (file_exists($file)) {
	            $size = filesize($file);

	            if ($size >= 5242880) {
	                $suffix = array(
	                    'B',
	                    'KB',
	                    'MB',
	                    'GB',
	                    'TB',
	                    'PB',
	                    'EB',
	                    'ZB',
	                    'YB'
	                );

	                $i = 0;

	                while (($size / 1024) > 1) {
	                    $size = $size / 1024;
	                    $i++;
	                }

	                $data['error_warning'] = sprintf($this->language->get('error_warning'), basename($file), round(substr($size, 0, strpos($size, '.') + 4), 2) . $suffix[$i]);
	            } else {
	                $data['sms_log'] = file_get_contents($file, FILE_USE_INCLUDE_PATH, null);
	            }
	        }
        }else{
        	$this->clearLog();
        }

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/module/targetsms', $data));

	}

	public function connect() {

		$json = $this->getSenders($this->request->post['module_targetsms_login'],$this->request->post['module_targetsms_password']);
		$json['balance'] = $this->getBalance($this->request->post['module_targetsms_login'],$this->request->post['module_targetsms_password']);
		$this->response->setOutput(json_encode($json));
	}

	public function getSenders($login,$password) {
		$param = array(
            'security' => array('login' => $login, 'password' => $password),
            'type' => 'originator'
        );

        $param_json = json_encode($param, true);
        // JSON-документ
        $href = 'https://sms.targetsms.ru/sendsmsjson.php'; // адрес сервера
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
        curl_setopt($ch, CURLOPT_URL, $href);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
        $res = curl_exec($ch);
        $result = json_decode($res, true);
        curl_close($ch);
     
        return $result;
	}

	public function getBalance($login,$password) {
        $param = array(
			'security' => array('login' => $login, 'password' => $password),
			'type' => 'balance'
		);


        $param_json = json_encode($param, true);
        // JSON-документ
        $href = 'https://sms.targetsms.ru/sendsmsjson.php'; // адрес сервера
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
        curl_setopt($ch, CURLOPT_URL, $href);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
        $res = curl_exec($ch);
        $result = json_decode($res, true);
        curl_close($ch);

		if (isset($result['money']['value'])) {
			return $result['money']['value'];
		} else {
			return false;
		}
        
	}

	public function getMessages() {
		$param = array(
		 'security' => array('login' => $this->request->post['module_targetsms_login'], 'password' => $this->request->post['module_targetsms_password']),
		 'type' => 'list_stats',
		 'stats' => array('date_start' => $this->request->post['date_start'], 'date_stop' => $this->request->post['date_stop'], 'state' => $this->request->post['state'], 'originator' => $this->request->post['module_targetsms_from'])
		);

		/*$param = array(
		 'security' => array('login' => 'tsms', 'password' => '123'),
		 'type' => 'list_stats',
		 'stats' => array('date_start' => '2000-01-01', 'date_stop' => '2019-01-01', 'state' => 'not_deliver', 'originator' => 'target')
		);*/



		$param_json = json_encode($param, true);
        // JSON-документ
        $href = 'https://sms.targetsms.ru/sendsmsjson.php'; // адрес сервера
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
        curl_setopt($ch, CURLOPT_URL, $href);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
        $res = curl_exec($ch);
        //$result = json_decode($res, true);
        curl_close($ch);

        //var_dump($result);exit;
        $this->response->setOutput($res);

	}

	public function orderSms() {
		$this->load->model('setting/setting');
		$module_targetsms_login = $this->model_setting_setting->getSettingValue('module_targetsms_login',$this->request->post['store_id']);
		$module_targetsms_password = $this->model_setting_setting->getSettingValue('module_targetsms_password',$this->request->post['store_id']);
		$module_targetsms_from = $this->model_setting_setting->getSettingValue('module_targetsms_from',$this->request->post['store_id']);
		$phone = $this->request->post['phone'];
		$phone = str_replace(")","",$phone);
		$phone = str_replace("(","",$phone);
		$phone = str_replace("-","",$phone);
		$phone = str_replace(" ","",$phone);
		$phone = str_replace("+","",$phone);

		$first_3 = substr($phone,0,3);
		$first_1 = substr($phone,0,1);
		$error = 0;

		if (($first_3 == '380') || ($first_3 == '375')) {
			$last = substr($phone,3);
			if (strlen($last) == 9) {
				$phone = "+" . $phone;
			} else {
				$error = 1;
			}
			
		} elseif ($first_1 == '7') {
			$last = substr($phone,1);
			if (strlen($last) == 10) {
				$phone = "+" . $phone;
			} else {
				$error = 1;
			}

		} elseif ($first_1 == '8') {
			$last = substr($phone,1);
			if (strlen($last) == 10) {
				$phone = "+7" . $last;
			} else {
				$error = 1;
			}
		} else {
			$error = 1;
		}

		if (!$error) {

			$param = array(
				'security' => array('login' => $module_targetsms_login, 'password' => $module_targetsms_password),
				'type' => 'sms',
				'message' => array(
					array(
						'type' => 'sms',
						'name_delivery' => 'opencartorders3_0_sendmanualsms',
						'sender' => $module_targetsms_from,
						'text' => $this->request->post['message'],
						'abonent' => array(
							array('phone' => $phone, 'number_sms' => '1')
						)
					)
				)
			);
			
			$param_json = json_encode($param, true);
	        // JSON-документ
	        $href = 'https://sms.targetsms.ru/sendsmsjson.php'; // адрес сервера
	        $ch = curl_init();
	        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
	        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	        curl_setopt($ch, CURLOPT_POST, true);
	        curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
	        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
	        curl_setopt($ch, CURLOPT_URL, $href);
	        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
	        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
	        $res = curl_exec($ch);
	        $result = json_decode($res, true);
	        curl_close($ch);
		} else {
			$result = array();
			$result['error'] = "Неверный формат номера";
		}
	
        $this->response->setOutput(json_encode($result));
		

	}

	public function testSms() {

		$phone = $this->request->post['phone'];
		$phone = str_replace(")","",$phone);
		$phone = str_replace("(","",$phone);
		$phone = str_replace("-","",$phone);
		$phone = str_replace(" ","",$phone);
		$phone = str_replace("+","",$phone);

		$first_3 = substr($phone,0,3);
		$first_1 = substr($phone,0,1);
		$error = 0;

		if (($first_3 == '380') || ($first_3 == '375')) {
			$last = substr($phone,3);
			if (strlen($last) == 9) {
				$phone = "+" . $phone;
			} else {
				$error = 1;
			}
			
		} elseif ($first_1 == '7') {
			$last = substr($phone,1);
			if (strlen($last) == 10) {
				$phone = "+" . $phone;
			} else {
				$error = 1;
			}

		} elseif ($first_1 == '8') {
			$last = substr($phone,1);
			if (strlen($last) == 10) {
				$phone = "+7" . $last;
			} else {
				$error = 1;
			}
		} else {
			$error = 1;
		}

		if (!$error) {
			$param = array(
				'security' => array('login' => $this->request->post['module_targetsms_login'], 'password' => $this->request->post['module_targetsms_password']),
				'type' => 'sms',
				'message' => array(
					array(
						'type' => 'sms',
						'name_delivery' => 'opencartorders3_0_sendmanualsms',
						'sender' => $this->request->post['module_targetsms_from'],
						'text' => $this->request->post['message'],
						'abonent' => array(
							array('phone' => $phone, 'number_sms' => '1')
						)
					)
				)
			);
			$param_json = json_encode($param, true);
	        // JSON-документ
	        $href = 'https://sms.targetsms.ru/sendsmsjson.php'; // адрес сервера
	        $ch = curl_init();
	        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
	        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	        curl_setopt($ch, CURLOPT_POST, true);
	        curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
	        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
	        curl_setopt($ch, CURLOPT_URL, $href);
	        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
	        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
	        $res = curl_exec($ch);
	        $result = json_decode($res, true);
	        curl_close($ch);
		} else {
			$result = array();
			$result['error'] = "Неверный формат номера";
		}
	
        $this->response->setOutput(json_encode($result));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/targetsms')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}

    public function clearLog() {

        $json = array();
        
        $this->load->language('extension/module/targetsms');

        if (!$this->user->hasPermission('modify', 'extension/module/targetsms')) {
            $json['error'] = $this->language->get('error_permission');
        } else {
                $file = DIR_LOGS . 'sms_log.log';

                $handle = fopen($file, 'w+');

                fclose($handle);

                $json['success'] = $this->language->get('text_success_log');
        }

        $this->response->setOutput(json_encode($json));
    }
}